import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ArticleCategory, ArticleCategoryParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询文章分类
 */
export async function pageArticleCategory(params: ArticleCategoryParam) {
  const res = await request.get<ApiResult<PageResult<ArticleCategory>>>(
    MODULES_API_URL + '/cms/article-category/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询文章分类列表
 */
export async function listArticleCategory(params?: ArticleCategoryParam) {
  const res = await request.get<ApiResult<ArticleCategory[]>>(
    MODULES_API_URL + '/cms/article-category',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询文章分类
 */
export async function getArticleCategory(id: number) {
  const res = await request.get<ApiResult<ArticleCategory>>(
    MODULES_API_URL + '/cms/article-category/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加文章分类
 */
export async function addArticleCategory(data: ArticleCategory) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/cms/article-category',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改文章分类
 */
export async function updateArticleCategory(data: ArticleCategory) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/cms/article-category',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除文章分类
 */
export async function removeArticleCategory(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/cms/article-category/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除文章分类
 */
export async function removeBatchArticleCategory(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/cms/article-category/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 检查IP是否存在
 */
export async function checkExistence(
  field: string,
  value: string,
  id?: number
) {
  const res = await request.get<ApiResult<unknown>>(
    MODULES_API_URL + '/cms/article-category/existence',
    {
      params: { field, value, id }
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}
